import 'dart:io';
import 'package:flutter/material.dart';


String wemo_set(value)
{
	return """
POST /upnp/control/basicevent1 HTTP/1.0
Content-type: text/xml; charset="utf-8"
SOAPACTION: "urn:Belkin:service:basicevent:1#SetBinaryState"
Content-Length: 299

<?xml version="1.0" encoding="utf-8"?><s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/" s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><s:Body><u:SetBinaryState xmlns:u="urn:Belkin:service:basicevent:1"><BinaryState>${value}</BinaryState></u:SetBinaryState></s:Body></s:Envelope>
""";
}


//example host = "192.168.1.12"
// example msg = wemo_set(0)  // for off
//         msg = wemo_set(1)  // for on

void wemoSend(host, msg) async
{
	Socket.connect(host, 49153).then(
			(Socket sock) {
				sock.write(msg);
				sock.close();
			}
			);
}

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'ESE 150 Demo',
      theme: ThemeData(
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(title: 'ESE150 Lab 12 mobile outlet'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);

  // This widget is the home page of your application. It is stateful, meaning
  // that it has a State object (defined below) that contains fields that affect
  // how it looks.

  // This class is the configuration for the state. It holds the values (in this
  // case the title) provided by the parent (in this case the App widget) and
  // used by the build method of the State. Fields in a Widget subclass are
  // always marked "final".

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

bool insight_1 = true;
String text_1 = "no message";
String selected_wemo = "One";

class _MyHomePageState extends State<MyHomePage> {

  @override
  Widget build(BuildContext context) {
    // This method is rerun every time setState is called, for instance as done
    // by the _incrementCounter method above.
    //
    // The Flutter framework has been optimized to make rerunning build methods
    // fast, so that you can just rebuild anything that needs updating rather
    // than having to individually change instances of widgets.
    return Scaffold(
      appBar: AppBar(
        // Here we take the value from the MyHomePage object that was created by
        // the App.build method, and use it to set our appbar title.
        title: Text(widget.title),
      ),
      body: Center(
        // Center is a layout widget. It takes a single child and positions it
        // in the middle of the parent.
        child: Column(
          // Column is also layout widget. It takes a list of children and
          // arranges them vertically. By default, it sizes itself to fit its
          // children horizontally, and tries to be as tall as its parent.
          //
          // Invoke "debug painting" (press "p" in the console, choose the
          // "Toggle Debug Paint" action from the Flutter Inspector in Android
          // Studio, or the "Toggle Debug Paint" command in Visual Studio Code)
          // to see the wireframe for each widget.
          //
          // Column has various properties to control how it sizes itself and
          // how it positions its children. Here we use mainAxisAlignment to
          // center the children vertically; the main axis here is the vertical
          // axis because Columns are vertical (the cross axis would be
          // horizontal).
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text("Last message: "+text_1),
            FlatButton(onPressed: () {
                                        print("FlatButton fired");
			                setState(() {text_1 = ("FlatButton 1");});
                                     },
                child: Text('Flat Button 1')),
            RaisedButton(onPressed: () {
                                        print("RaisedButton fired");
			                setState(() {text_1 = ("RaisedButton 2");});
                                     },
                child: Text('Raised Button 2')),
            FloatingActionButton(onPressed: () {
                                        print("FloatingActionButton fired");
			                setState(() {text_1 = ("FloatingActionButton 3");});
                                     },
                child: Text('FAB 3')),
            Text("switch 4:"),
	    Switch(
		    value: insight_1,
		    onChanged: (value) {
			    setState(() {
			    insight_1 = value;
                            // note: could use value here with call to wemo_set()
			    print("Switch 4 fired.  New state: $value");
			    text_1 = ("switch4");
			    });
		    }
		    ),
	    DropdownButton<String>(
			    /* This example copied from the flutter docs:
			       https://docs.flutter.io/flutter/material/DropdownButton-class.html
			       */
			    value: selected_wemo,
			    onChanged: (String newValue) {
				    setState(() {
					    selected_wemo = newValue;
                                            text_1=("DropdownButton 5 "+newValue);
					    print("DropdownButton selected: $newValue");
				    });
			    },
			    items: <String>['One', 'Two', 'Three', 'Four']
			    .map<DropdownMenuItem<String>>((String value) {
				    return DropdownMenuItem<String>(
						    value: value,
						    child: Text(value),
						    );
			    })
			    .toList(),
			    ),
          ],
        ),
      ),
    );
  }
}
