#!/usr/bin/env python                                                                                                                                                                                       

import pygtk
pygtk.require('2.0')
import gtk
import os
import socket
from subprocess import call
import re

wemo_off="""
POST /upnp/control/basicevent1 HTTP/1.0
Content-type: text/xml; charset="utf-8"
SOAPACTION: "urn:Belkin:service:basicevent:1#SetBinaryState"
Content-Length: 299

<?xml version="1.0" encoding="utf-8"?><s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/" s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><s:Body><u:SetBinaryState xmlns:u="urn:Belkin:service:basicevent:1"><BinaryState>0</BinaryState></u:SetBinaryState></s:Body></s:Envelope>
"""

wemo_on="""
POST /upnp/control/basicevent1 HTTP/1.0
Content-type: text/xml; charset="utf-8"
SOAPACTION: "urn:Belkin:service:basicevent:1#SetBinaryState"
Content-Length: 299

<?xml version="1.0" encoding="utf-8"?><s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/" s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><s:Body><u:SetBinaryState xmlns:u="urn:Belkin:service:basicevent:1"><BinaryState>1</BinaryState></u:SetBinaryState></s:Body></s:Envelope>
"""
class MyProgram:
    
    #add more Wemo devices if needed
    targets = [("Insight 1", "10.103.213.20"),
               ("Insight 2", "10.103.214.245")]
    
    def sendCommand(self,host, command):
        ret = None
        try:
            s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            s.settimeout(100)
            # open a socket to the specified host (IP address) on the WEMO control port
            s.connect((host, 49153))
            # send the specified command string
            s.send(command)
            # listen for a result
            ret = s.recv(1024)
            # close the socket
            s.close()
        except Exception as e:
            print e
            print "error in sendCommand"
            s.close()
        return ret
    

    # This wraps sendCommand (above) so you can use it as a callback routine
    def sendCallback(self, widget, data):
        self.sendCommand(*data)

    #This is a call back function which creates a dialogue box when an event occurs. 
    def dialogue(self, widget, data):
        dialog = gtk.Dialog(data,
                   None,
                   gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                   (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
        dialog.set_size_request(300,50)
        dialog.run()
        dialog.destroy()

    def __init__(self):


        # create a new window
        self.app_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        # set the size of the window (height, width)    
        self.app_window.set_size_request(500, 500)
        self.app_window.set_border_width(10)
        #title of the window
        self.app_window.set_title("ESE150-Lab12 (single)")
        self.app_window.connect("delete_event", lambda w,e: gtk.main_quit())
        
        #This a Vertical Box or a VBox
        self.vbox_app = gtk.VBox(False, 0)
        #Create a label 
        self.label_app = gtk.Label("Lego Models: ")
        #pack that label in the VBox. This is the first widget that shows in your gui
        self.vbox_app.pack_start(self.label_app, False, False, 10)
        
        #create a horizontal box where all your wemo on-off buttons go. 
        self.hbox_wemos = gtk.HBox(False, 0)
        
        #create a vertical box for wemo1 device
        self.wemo1 = gtk.VBox(False, 0)

#TODO for single_outlet.py -- Change model name to match your model
        self.label = gtk.Label("Device 1: YOUR MODEL")
        self.wemo1.pack_start(self.label, False, False, 5)
        
        #Create a HBox for on-off buttons
        self.wemo=gtk.HBox(False, 0)

        self.on=gtk.Button("On")
        self.on.connect("clicked",self.dialogue, "You just clicked the on button")
#TODO for single_outlet.py --  Change to this callback
#   ...after you change the IP address to match the wemo device at your station
#        self.on.connect("clicked", self.sendCallback, ("10.103.213.20",wemo_on))
        self.wemo.pack_start(self.on,True, True, 10)
        
        self.off=gtk.Button("Off")
        self.off.connect("clicked",self.dialogue, "You just clicked the off button")
#TODO for single_outlet.py --  Change the callback here for off similar to the one above... use wemo_off string.        
        self.wemo.pack_start(self.off,True, True, 10)

        self.wemo1.pack_start(self.wemo, True, True,15)
        
        self.hbox_wemos.pack_start(self.wemo1, True, True, 15)


# Changes here for expanding to multi_outlet.py
        #TODO: create the same for wemo2 and wemo3
        #TODO: change the window size accordingly- increase the width of the window.
        
        #wemo2


        #wemo3



        # END OF TODO
        
        #pack the horizontol box of wemos to the main VBox
        self.vbox_app.pack_start(self.hbox_wemos, True, True, 15)

        self.separator = gtk.HSeparator()
        self.vbox_app.pack_start(self.separator, False, True, 5)



        self.app_window.add(self.vbox_app)
        self.app_window.show_all()

        return

def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    MyProgram()
    main()


